//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SMSCAmain.h"
#include "SMSCAview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  InFormat->ItemIndex = 0;
}
//---------------------------------------------------------------------------
AnsiString ConvertFromGluk(AnsiString gluk)
{
  unsigned char *retbuf, ch, ch1;
  char wrbuf[2];
  int len;
  AnsiString ret;
  retbuf = gluk.c_str();
  len = gluk.Length();
  for (int i=0; i<len; i++)
  {
    ch = retbuf[i];
    if (ch==176) ch=134;  //SC
    if (ch==177) ch=166;  //SC
    //TRANSCODING RUSSIAN SYMBOLS (866 to 1251)
    ch1 = ch;
    if (((ch1>=160) && (ch1<=175)) || ((ch1>=128)&&(ch1<=159)))
     ch += 64;
    else
    {
     if ((ch1>=224)&&(ch1<=239)) ch += 16;
     else
     {
       if (ch1==240) ch=168; //
       if (ch1==241) ch=184; //
     }//end else
    }//end else
    wrbuf[1] = '\0';
    wrbuf[0] = (char)ch;
    ret += wrbuf;
  }// end for(int i=0; i<len; i++)
  return ret;
}//end ConvertFromGluk
//------------------------------------
AnsiString ConvertFromWinda(AnsiString winda)
{
  unsigned char *retbuf, ch;
  char wrbuf[2];
  int len;
  AnsiString ret;
  retbuf = winda.c_str();
  len = winda.Length();
  for (int i=0; i<len; i++)
  {
    ch = retbuf[i];
    //TRANSCODING RUSSIAN SYMBOLS (1251 to 866)
    if (ch>=240) ch-=16;
    else
    {
      if ((ch>=192)&&(ch<=239)) ch-=64;
      else
      {
        if (ch==168) ch=240; //
        if (ch==184) ch=241; //
      }//end
    }//end else
    if (ch==240) ch=133; //SC
    if (ch==241) ch=165; //SC
    if (ch==134) ch=176; //SC
    if (ch==166) ch=177; //SC
    wrbuf[1] = '\0';
    wrbuf[0] = (char)ch;
    ret += wrbuf;
  }// end for(int i=0; i<len; i++)
  return ret;
}//end ConvertFromWinda
//-------------------------------

void __fastcall TForm1::ClearButtonClick(TObject *Sender)
{
  Memo1->Clear();
  Boyan->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PasteButtonClick(TObject *Sender)
{
  WasInMemo = Memo1->Text;
  Memo1->Clear();
  Memo1->PasteFromClipboard();
  if (WasInMemo == Memo1->Text)
    Boyan->Visible = true;
  else
    Boyan->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoyanClick(TObject *Sender)
{
  Application->MessageBox("  !",
    " ", MB_OK | MB_ICONWARNING);  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GoButtonClick(TObject *Sender)
{
  int enc = InFormat->ItemIndex;
  if (enc==0)
  {
    HlamView->Result->Text = ConvertFromGluk(Memo1->Text);
  }
  if (enc==1)
  {
    HlamView->Result->Text = ConvertFromWinda(Memo1->Text);
  }
  HlamView->ShowModal();
}
//---------------------------------------------------------------------------

